﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GenericFamilyRelation
{
    class AnimalFamilyRelation
    {
        public AnimalFamilyRelation(Animal self, Animal father, Animal mother)
        {
            Self = self;
            Father = father;
            Mother = mother;
            Children = new List<Animal>();
        }

        public Animal Self { get; }

        public Animal Father { get; }

        public Animal Mother { get; }

        public List<Animal> Children { get; }

        public void AddChild(Animal child)
        {
            Children.Add(child);
        }
    }
}
}
