﻿using System.Collections.Generic;

namespace GenericFamilyRelation
{
    public class DogFamilyRelation
    {
        public DogFamilyRelation(Dog self, Dog father, Dog mother)
        {
            Self = self;
            Father = father;
            Mother = mother;
            Children = new List<Dog>();
        }

        public Dog Self { get; }

        public Dog Father { get; }

        public Dog Mother { get; }

        public List<Dog> Children { get; }

        public void AddChild(Dog child)
        {
            Children.Add(child);
        }
    }

}
