﻿using System;
using GenericFamilyRelation;

namespace GenericFamilyRelation
{
    class Program
    {
        static void Main(string[] args)
        {
            Dog self = new Dog("King");
            Dog mom = new Dog("Spot");
            Dog dad = new Dog("Rufus");

            DogFamilyRelation relations = new DogFamilyRelation(self, dad, mom);
            relations.AddChild(new Dog("Lajka"));


            AnimalFamilyRelation dogRelations = new AnimalFamilyRelation(self, dad, mom);
            dogRelations.AddChild(new Dog("Lajka"));

            Cat a = new Cat("Stripe");
            Cat b = new Cat("Socks");
            Cat c = new Cat("Abby");

            AnimalFamilyRelation catRelations = new AnimalFamilyRelation(a, b, c);
            catRelations.AddChild(new Cat("Miau"));


            //Problem: nedarvning giver ikke den ønskede funktionalitet da man kam mikse typerne
            catRelations.AddChild(new Dog("Rollo"));


            GenericFamilyRelation<Dog> dogRelations2 = new GenericFamilyRelation<Dog>(self, dad, mom);
            dogRelations2.AddChild(new Dog("Lajka"));

            //dogRelations2.AddChild(new Cat("Miau")); Ikke lovligt da Cat ikke er af typen Dog

            GenericFamilyRelation<Cat> catRelations2 = new GenericFamilyRelation<Cat>(a, b, c);
            catRelations2.AddChild(new Cat("Miau"));

        }
    }


}
